package it.uniroma2.sag.assignment.ir.lucene.cranfield;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;

public class CranDocument {

	@SuppressWarnings("deprecation")
	public static Document Document(File f)
			throws java.io.FileNotFoundException {
		Document doc = new Document();
		doc.add(new Field("path", f.getPath(), Field.Store.YES,
				Field.Index.NOT_ANALYZED));
		doc.add(new Field("ID", f.getName(), Field.Store.YES,
				Field.Index.NOT_ANALYZED));
		String acc = "";
		BufferedReader file = new BufferedReader(new FileReader(f));
		String inputLine = "";
		boolean title_text = false;
		try {
			while ((inputLine = file.readLine()) != null) {
				if (inputLine.startsWith(".T")) {
					title_text = true;
				} else if (inputLine.startsWith(".A")) {
					Field title = new Field("title", acc, Field.Store.YES,
							Field.Index.ANALYZED);
					doc.add(title);
					acc = "";
					title_text = false;
				} else if (inputLine.startsWith(".B")) {
					title_text = false;
				} else if (inputLine.startsWith(".W")) {
					title_text = true;
				} else {
					if (title_text)
						acc = acc.concat(inputLine + " ");
				}
			}
		} catch (Exception e) {
			doc.add(new Field("text", acc, Field.Store.YES,
					Field.Index.ANALYZED));
			acc = "";
			try {
				file.close();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		doc.add(new Field("text", acc, Field.Store.YES, Field.Index.ANALYZED));
		return doc;
	}
}
