package it.uniroma2.sag.assignment.ir.lucene.index;

import it.uniroma2.sag.assignment.ir.lucene.analyzer.DummyCranfieldAnalyzer;
import it.uniroma2.sag.assignment.ir.lucene.cranfield.CranDocument;

import java.io.File;
import java.io.IOException;

import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.IndexWriterConfig;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.SimpleFSDirectory;
import org.apache.lucene.util.Version;

public class DummyCranIndexer {
	public static void main(String[] args) throws IOException {
		DummyCranfieldAnalyzer analyzer = new DummyCranfieldAnalyzer();
		Directory index = new SimpleFSDirectory(new File("resources/dca_cranindex"));
		IndexWriterConfig config = new IndexWriterConfig(Version.LUCENE_36, analyzer);
		IndexWriter w = new IndexWriter(index, config);
		
		String cranPath = "resources/cranfield_collection_splitted";
		File f = new File(cranPath);
		for (File file : f.listFiles()) {
			Document d = CranDocument.Document(file);
			w.addDocument(d);
		} 
		
		w.commit();
		w.close();
		
		index.close();
	}
}
