package it.uniroma2.sag.assignment.ir.lucene.search;

import it.uniroma2.sag.assignment.ir.lucene.analyzer.DummyCranfieldAnalyzer;

import java.io.File;
import java.io.IOException;

import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.queryParser.ParseException;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.ScoreDoc;
import org.apache.lucene.search.TopScoreDocCollector;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.SimpleFSDirectory;
import org.apache.lucene.util.Version;

public class DummyCranSearch {

	@SuppressWarnings("deprecation")
	public static void main(String[] args) throws IOException, ParseException {
		DummyCranfieldAnalyzer analyzer = new DummyCranfieldAnalyzer();
		String querystr = "text:(what similarity laws must be obeyed when constructing aeroelastic models of heated high speed aircraft .)";
		Query q = new QueryParser(Version.LUCENE_36, "text", analyzer)
				.parse(querystr);

		Directory index = new SimpleFSDirectory(new File(
				"resources/dca_cranindex"));
		int hitsPerPage = 15;
		IndexReader reader = IndexReader.open(index);
		IndexSearcher searcher = new IndexSearcher(reader);
		TopScoreDocCollector collector = TopScoreDocCollector.create(
				hitsPerPage, true);
		searcher.search(q, collector);
		ScoreDoc[] hits = collector.topDocs().scoreDocs;

		System.out.println("Found " + hits.length + " hits.");
		for (int i = 0; i < hits.length; ++i) {
			int docId = hits[i].doc;
			Document d = searcher.doc(docId);
			System.out.println((d.get("ID"))+ "\t" + d.get("text"));
		}
		searcher.close();
	}
}
